#ifndef _SEGMENT_SYMBOLS_H_
#define _SEGMENT_SYMBOLS_H_

#include <z64.h>

#define DECLARE_SEGMENT(name)          \
    extern u8 _##name##SegmentStart[]; \
    extern u8 _##name##SegmentEnd[];

#define DECLARE_ROM_SEGMENT(name)         \
    extern u8 _##name##SegmentRomStart[]; \
    extern u8 _##name##SegmentRomEnd[];

#define DECLARE_BSS_SEGMENT(name)         \
    extern u8 _##name##SegmentBssStart[]; \
    extern u8 _##name##SegmentBssEnd[];

#define DECLARE_OVERLAY_SEGMENT(name) \
    DECLARE_SEGMENT(ovl_##name)       \
    DECLARE_ROM_SEGMENT(ovl_##name)

DECLARE_SEGMENT(boot)
DECLARE_ROM_SEGMENT(boot)

DECLARE_SEGMENT(dmadata)
DECLARE_ROM_SEGMENT(dmadata)

DECLARE_ROM_SEGMENT(Audiobank)
DECLARE_ROM_SEGMENT(Audioseq)
DECLARE_ROM_SEGMENT(Audiotable)
DECLARE_ROM_SEGMENT(link_animetion)
DECLARE_ROM_SEGMENT(icon_item_static)
DECLARE_ROM_SEGMENT(icon_item_24_static)
DECLARE_ROM_SEGMENT(icon_item_field_static)
DECLARE_ROM_SEGMENT(icon_item_dungeon_static)
DECLARE_ROM_SEGMENT(icon_item_gameover_static)
DECLARE_ROM_SEGMENT(icon_item_nes_static)
DECLARE_ROM_SEGMENT(icon_item_ger_static)
DECLARE_ROM_SEGMENT(icon_item_fra_static)
DECLARE_ROM_SEGMENT(item_name_static)
DECLARE_ROM_SEGMENT(map_name_static)
DECLARE_ROM_SEGMENT(do_action_static)
DECLARE_ROM_SEGMENT(message_static)
DECLARE_ROM_SEGMENT(message_texture_static)
DECLARE_ROM_SEGMENT(nes_font_static)
DECLARE_ROM_SEGMENT(nes_message_data_static)
DECLARE_ROM_SEGMENT(ger_message_data_static)
DECLARE_ROM_SEGMENT(fra_message_data_static)
DECLARE_ROM_SEGMENT(staff_message_data_static)
DECLARE_ROM_SEGMENT(map_grand_static)
DECLARE_ROM_SEGMENT(map_i_static)
DECLARE_ROM_SEGMENT(map_48x85_static)

DECLARE_SEGMENT(code)
DECLARE_ROM_SEGMENT(code)
DECLARE_BSS_SEGMENT(code)

DECLARE_OVERLAY_SEGMENT(title)
DECLARE_OVERLAY_SEGMENT(select)
DECLARE_OVERLAY_SEGMENT(opening)
DECLARE_OVERLAY_SEGMENT(file_choose)
DECLARE_OVERLAY_SEGMENT(kaleido_scope)
DECLARE_OVERLAY_SEGMENT(player_actor)
DECLARE_OVERLAY_SEGMENT(map_mark_data)

DECLARE_OVERLAY_SEGMENT(Effect_Ss_Dust)
DECLARE_OVERLAY_SEGMENT(Effect_Ss_KiraKira)
DECLARE_OVERLAY_SEGMENT(Effect_Ss_Bomb)
DECLARE_OVERLAY_SEGMENT(Effect_Ss_Bomb2)
DECLARE_OVERLAY_SEGMENT(Effect_Ss_Blast)
DECLARE_OVERLAY_SEGMENT(Effect_Ss_G_Spk)
DECLARE_OVERLAY_SEGMENT(Effect_Ss_D_Fire)
DECLARE_OVERLAY_SEGMENT(Effect_Ss_Bubble)
DECLARE_OVERLAY_SEGMENT(Effect_Ss_G_Ripple)
DECLARE_OVERLAY_SEGMENT(Effect_Ss_G_Splash)
DECLARE_OVERLAY_SEGMENT(Effect_Ss_G_Magma)
DECLARE_OVERLAY_SEGMENT(Effect_Ss_G_Fire)
DECLARE_OVERLAY_SEGMENT(Effect_Ss_Lightning)
DECLARE_OVERLAY_SEGMENT(Effect_Ss_Dt_Bubble)
DECLARE_OVERLAY_SEGMENT(Effect_Ss_Hahen)
DECLARE_OVERLAY_SEGMENT(Effect_Ss_Stick)
DECLARE_OVERLAY_SEGMENT(Effect_Ss_Sibuki)
DECLARE_OVERLAY_SEGMENT(Effect_Ss_Sibuki2)
DECLARE_OVERLAY_SEGMENT(Effect_Ss_G_Magma2)
DECLARE_OVERLAY_SEGMENT(Effect_Ss_Stone1)
DECLARE_OVERLAY_SEGMENT(Effect_Ss_HitMark)
DECLARE_OVERLAY_SEGMENT(Effect_Ss_Fhg_Flash)
DECLARE_OVERLAY_SEGMENT(Effect_Ss_K_Fire)
DECLARE_OVERLAY_SEGMENT(Effect_Ss_Solder_Srch_Ball)
DECLARE_OVERLAY_SEGMENT(Effect_Ss_Kakera)
DECLARE_OVERLAY_SEGMENT(Effect_Ss_Ice_Piece)
DECLARE_OVERLAY_SEGMENT(Effect_Ss_En_Ice)
DECLARE_OVERLAY_SEGMENT(Effect_Ss_Fire_Tail)
DECLARE_OVERLAY_SEGMENT(Effect_Ss_En_Fire)
DECLARE_OVERLAY_SEGMENT(Effect_Ss_Extra)
DECLARE_OVERLAY_SEGMENT(Effect_Ss_Fcircle)
DECLARE_OVERLAY_SEGMENT(Effect_Ss_Dead_Db)
DECLARE_OVERLAY_SEGMENT(Effect_Ss_Dead_Dd)
DECLARE_OVERLAY_SEGMENT(Effect_Ss_Dead_Ds)
DECLARE_OVERLAY_SEGMENT(Effect_Ss_Dead_Sound)
DECLARE_OVERLAY_SEGMENT(Effect_Ss_Ice_Smoke)

DECLARE_OVERLAY_SEGMENT(En_Test)
DECLARE_OVERLAY_SEGMENT(En_GirlA)
DECLARE_OVERLAY_SEGMENT(En_Part)
DECLARE_OVERLAY_SEGMENT(En_Light)
DECLARE_OVERLAY_SEGMENT(En_Door)
DECLARE_OVERLAY_SEGMENT(En_Box)
DECLARE_OVERLAY_SEGMENT(Bg_Dy_Yoseizo)
DECLARE_OVERLAY_SEGMENT(Bg_Hidan_Firewall)
DECLARE_OVERLAY_SEGMENT(En_Poh)
DECLARE_OVERLAY_SEGMENT(En_Okuta)
DECLARE_OVERLAY_SEGMENT(Bg_Ydan_Sp)
DECLARE_OVERLAY_SEGMENT(En_Bom)
DECLARE_OVERLAY_SEGMENT(En_Wallmas)
DECLARE_OVERLAY_SEGMENT(En_Dodongo)
DECLARE_OVERLAY_SEGMENT(En_Firefly)
DECLARE_OVERLAY_SEGMENT(En_Horse)
DECLARE_OVERLAY_SEGMENT(En_Item00)
DECLARE_OVERLAY_SEGMENT(En_Arrow)
DECLARE_OVERLAY_SEGMENT(En_Elf)
DECLARE_OVERLAY_SEGMENT(En_Niw)
DECLARE_OVERLAY_SEGMENT(En_Tite)
DECLARE_OVERLAY_SEGMENT(En_Reeba)
DECLARE_OVERLAY_SEGMENT(En_Peehat)
DECLARE_OVERLAY_SEGMENT(En_Butte)
DECLARE_OVERLAY_SEGMENT(En_Insect)
DECLARE_OVERLAY_SEGMENT(En_Fish)
DECLARE_OVERLAY_SEGMENT(En_Holl)
DECLARE_OVERLAY_SEGMENT(En_Scene_Change)
DECLARE_OVERLAY_SEGMENT(En_Zf)
DECLARE_OVERLAY_SEGMENT(En_Hata)
DECLARE_OVERLAY_SEGMENT(Boss_Dodongo)
DECLARE_OVERLAY_SEGMENT(Boss_Goma)
DECLARE_OVERLAY_SEGMENT(En_Zl1)
DECLARE_OVERLAY_SEGMENT(En_Viewer)
DECLARE_OVERLAY_SEGMENT(En_Goma)
DECLARE_OVERLAY_SEGMENT(Bg_Pushbox)
DECLARE_OVERLAY_SEGMENT(En_Bubble)
DECLARE_OVERLAY_SEGMENT(Door_Shutter)
DECLARE_OVERLAY_SEGMENT(En_Dodojr)
DECLARE_OVERLAY_SEGMENT(En_Bdfire)
DECLARE_OVERLAY_SEGMENT(En_Boom)
DECLARE_OVERLAY_SEGMENT(En_Torch2)
DECLARE_OVERLAY_SEGMENT(En_Bili)
DECLARE_OVERLAY_SEGMENT(En_Tp)
DECLARE_OVERLAY_SEGMENT(En_St)
DECLARE_OVERLAY_SEGMENT(En_Bw)
DECLARE_OVERLAY_SEGMENT(En_A_Obj)
DECLARE_OVERLAY_SEGMENT(En_Eiyer)
DECLARE_OVERLAY_SEGMENT(En_River_Sound)
DECLARE_OVERLAY_SEGMENT(En_Horse_Normal)
DECLARE_OVERLAY_SEGMENT(En_Ossan)
DECLARE_OVERLAY_SEGMENT(Bg_Treemouth)
DECLARE_OVERLAY_SEGMENT(Bg_Dodoago)
DECLARE_OVERLAY_SEGMENT(Bg_Hidan_Dalm)
DECLARE_OVERLAY_SEGMENT(Bg_Hidan_Hrock)
DECLARE_OVERLAY_SEGMENT(En_Horse_Ganon)
DECLARE_OVERLAY_SEGMENT(Bg_Hidan_Rock)
DECLARE_OVERLAY_SEGMENT(Bg_Hidan_Rsekizou)
DECLARE_OVERLAY_SEGMENT(Bg_Hidan_Sekizou)
DECLARE_OVERLAY_SEGMENT(Bg_Hidan_Sima)
DECLARE_OVERLAY_SEGMENT(Bg_Hidan_Syoku)
DECLARE_OVERLAY_SEGMENT(En_Xc)
DECLARE_OVERLAY_SEGMENT(Bg_Hidan_Curtain)
DECLARE_OVERLAY_SEGMENT(Bg_Spot00_Hanebasi)
DECLARE_OVERLAY_SEGMENT(En_Mb)
DECLARE_OVERLAY_SEGMENT(En_Bombf)
DECLARE_OVERLAY_SEGMENT(En_Zl2)
DECLARE_OVERLAY_SEGMENT(Bg_Hidan_Fslift)
DECLARE_OVERLAY_SEGMENT(En_OE2)
DECLARE_OVERLAY_SEGMENT(Bg_Ydan_Hasi)
DECLARE_OVERLAY_SEGMENT(Bg_Ydan_Maruta)
DECLARE_OVERLAY_SEGMENT(Boss_Ganondrof)
DECLARE_OVERLAY_SEGMENT(En_Am)
DECLARE_OVERLAY_SEGMENT(En_Dekubaba)
DECLARE_OVERLAY_SEGMENT(En_M_Fire1)
DECLARE_OVERLAY_SEGMENT(En_M_Thunder)
DECLARE_OVERLAY_SEGMENT(Bg_Ddan_Jd)
DECLARE_OVERLAY_SEGMENT(Bg_Breakwall)
DECLARE_OVERLAY_SEGMENT(En_Jj)
DECLARE_OVERLAY_SEGMENT(En_Horse_Zelda)
DECLARE_OVERLAY_SEGMENT(Bg_Ddan_Kd)
DECLARE_OVERLAY_SEGMENT(Door_Warp1)
DECLARE_OVERLAY_SEGMENT(Obj_Syokudai)
DECLARE_OVERLAY_SEGMENT(Item_B_Heart)
DECLARE_OVERLAY_SEGMENT(En_Dekunuts)
DECLARE_OVERLAY_SEGMENT(Bg_Menkuri_Kaiten)
DECLARE_OVERLAY_SEGMENT(Bg_Menkuri_Eye)
DECLARE_OVERLAY_SEGMENT(En_Vali)
DECLARE_OVERLAY_SEGMENT(Bg_Mizu_Movebg)
DECLARE_OVERLAY_SEGMENT(Bg_Mizu_Water)
DECLARE_OVERLAY_SEGMENT(Arms_Hook)
DECLARE_OVERLAY_SEGMENT(En_fHG)
DECLARE_OVERLAY_SEGMENT(Bg_Mori_Hineri)
DECLARE_OVERLAY_SEGMENT(En_Bb)
DECLARE_OVERLAY_SEGMENT(Bg_Toki_Hikari)
DECLARE_OVERLAY_SEGMENT(En_Yukabyun)
DECLARE_OVERLAY_SEGMENT(Bg_Toki_Swd)
DECLARE_OVERLAY_SEGMENT(En_Fhg_Fire)
DECLARE_OVERLAY_SEGMENT(Bg_Mjin)
DECLARE_OVERLAY_SEGMENT(Bg_Hidan_Kousi)
DECLARE_OVERLAY_SEGMENT(Door_Toki)
DECLARE_OVERLAY_SEGMENT(Bg_Hidan_Hamstep)
DECLARE_OVERLAY_SEGMENT(En_Bird)
DECLARE_OVERLAY_SEGMENT(En_Wood02)
DECLARE_OVERLAY_SEGMENT(En_Lightbox)
DECLARE_OVERLAY_SEGMENT(En_Pu_box)
DECLARE_OVERLAY_SEGMENT(En_Trap)
DECLARE_OVERLAY_SEGMENT(En_Arow_Trap)
DECLARE_OVERLAY_SEGMENT(En_Vase)
DECLARE_OVERLAY_SEGMENT(En_Ta)
DECLARE_OVERLAY_SEGMENT(En_Tk)
DECLARE_OVERLAY_SEGMENT(Bg_Mori_Bigst)
DECLARE_OVERLAY_SEGMENT(Bg_Mori_Elevator)
DECLARE_OVERLAY_SEGMENT(Bg_Mori_Kaitenkabe)
DECLARE_OVERLAY_SEGMENT(Bg_Mori_Rakkatenjo)
DECLARE_OVERLAY_SEGMENT(En_Vm)
DECLARE_OVERLAY_SEGMENT(Demo_Effect)
DECLARE_OVERLAY_SEGMENT(Demo_Kankyo)
DECLARE_OVERLAY_SEGMENT(Bg_Hidan_Fwbig)
DECLARE_OVERLAY_SEGMENT(En_Floormas)
DECLARE_OVERLAY_SEGMENT(En_Heishi1)
DECLARE_OVERLAY_SEGMENT(En_Rd)
DECLARE_OVERLAY_SEGMENT(En_Po_Sisters)
DECLARE_OVERLAY_SEGMENT(Bg_Heavy_Block)
DECLARE_OVERLAY_SEGMENT(Bg_Po_Event)
DECLARE_OVERLAY_SEGMENT(Obj_Mure)
DECLARE_OVERLAY_SEGMENT(En_Sw)
DECLARE_OVERLAY_SEGMENT(Boss_Fd)
DECLARE_OVERLAY_SEGMENT(Object_Kankyo)
DECLARE_OVERLAY_SEGMENT(En_Du)
DECLARE_OVERLAY_SEGMENT(En_Fd)
DECLARE_OVERLAY_SEGMENT(En_Horse_Link_Child)
DECLARE_OVERLAY_SEGMENT(Door_Ana)
DECLARE_OVERLAY_SEGMENT(Bg_Spot02_Objects)
DECLARE_OVERLAY_SEGMENT(Bg_Haka)
DECLARE_OVERLAY_SEGMENT(Magic_Wind)
DECLARE_OVERLAY_SEGMENT(Magic_Fire)
DECLARE_OVERLAY_SEGMENT(En_Ru1)
DECLARE_OVERLAY_SEGMENT(Boss_Fd2)
DECLARE_OVERLAY_SEGMENT(En_Fd_Fire)
DECLARE_OVERLAY_SEGMENT(En_Dh)
DECLARE_OVERLAY_SEGMENT(En_Dha)
DECLARE_OVERLAY_SEGMENT(En_Rl)
DECLARE_OVERLAY_SEGMENT(En_Encount1)
DECLARE_OVERLAY_SEGMENT(Demo_Du)
DECLARE_OVERLAY_SEGMENT(Demo_Im)
DECLARE_OVERLAY_SEGMENT(Demo_Tre_Lgt)
DECLARE_OVERLAY_SEGMENT(En_Fw)
DECLARE_OVERLAY_SEGMENT(Bg_Vb_Sima)
DECLARE_OVERLAY_SEGMENT(En_Vb_Ball)
DECLARE_OVERLAY_SEGMENT(Bg_Haka_Megane)
DECLARE_OVERLAY_SEGMENT(Bg_Haka_MeganeBG)
DECLARE_OVERLAY_SEGMENT(Bg_Haka_Ship)
DECLARE_OVERLAY_SEGMENT(Bg_Haka_Sgami)
DECLARE_OVERLAY_SEGMENT(En_Heishi2)
DECLARE_OVERLAY_SEGMENT(En_Encount2)
DECLARE_OVERLAY_SEGMENT(En_Fire_Rock)
DECLARE_OVERLAY_SEGMENT(En_Brob)
DECLARE_OVERLAY_SEGMENT(Mir_Ray)
DECLARE_OVERLAY_SEGMENT(Bg_Spot09_Obj)
DECLARE_OVERLAY_SEGMENT(Bg_Spot18_Obj)
DECLARE_OVERLAY_SEGMENT(Boss_Va)
DECLARE_OVERLAY_SEGMENT(Bg_Haka_Tubo)
DECLARE_OVERLAY_SEGMENT(Bg_Haka_Trap)
DECLARE_OVERLAY_SEGMENT(Bg_Haka_Huta)
DECLARE_OVERLAY_SEGMENT(Bg_Haka_Zou)
DECLARE_OVERLAY_SEGMENT(Bg_Spot17_Funen)
DECLARE_OVERLAY_SEGMENT(En_Syateki_Itm)
DECLARE_OVERLAY_SEGMENT(En_Syateki_Man)
DECLARE_OVERLAY_SEGMENT(En_Tana)
DECLARE_OVERLAY_SEGMENT(En_Nb)
DECLARE_OVERLAY_SEGMENT(Boss_Mo)
DECLARE_OVERLAY_SEGMENT(En_Sb)
DECLARE_OVERLAY_SEGMENT(En_Bigokuta)
DECLARE_OVERLAY_SEGMENT(En_Karebaba)
DECLARE_OVERLAY_SEGMENT(Bg_Bdan_Objects)
DECLARE_OVERLAY_SEGMENT(Demo_Sa)
DECLARE_OVERLAY_SEGMENT(Demo_Go)
DECLARE_OVERLAY_SEGMENT(En_In)
DECLARE_OVERLAY_SEGMENT(En_Tr)
DECLARE_OVERLAY_SEGMENT(Bg_Spot16_Bombstone)
DECLARE_OVERLAY_SEGMENT(Bg_Hidan_Kowarerukabe)
DECLARE_OVERLAY_SEGMENT(Bg_Bombwall)
DECLARE_OVERLAY_SEGMENT(Bg_Spot08_Iceblock)
DECLARE_OVERLAY_SEGMENT(En_Ru2)
DECLARE_OVERLAY_SEGMENT(Obj_Dekujr)
DECLARE_OVERLAY_SEGMENT(Bg_Mizu_Uzu)
DECLARE_OVERLAY_SEGMENT(Bg_Spot06_Objects)
DECLARE_OVERLAY_SEGMENT(Bg_Ice_Objects)
DECLARE_OVERLAY_SEGMENT(Bg_Haka_Water)
DECLARE_OVERLAY_SEGMENT(En_Ma2)
DECLARE_OVERLAY_SEGMENT(En_Bom_Chu)
DECLARE_OVERLAY_SEGMENT(En_Horse_Game_Check)
DECLARE_OVERLAY_SEGMENT(Boss_Tw)
DECLARE_OVERLAY_SEGMENT(En_Rr)
DECLARE_OVERLAY_SEGMENT(En_Ba)
DECLARE_OVERLAY_SEGMENT(En_Bx)
DECLARE_OVERLAY_SEGMENT(En_Anubice)
DECLARE_OVERLAY_SEGMENT(En_Anubice_Fire)
DECLARE_OVERLAY_SEGMENT(Bg_Mori_Hashigo)
DECLARE_OVERLAY_SEGMENT(Bg_Mori_Hashira4)
DECLARE_OVERLAY_SEGMENT(Bg_Mori_Idomizu)
DECLARE_OVERLAY_SEGMENT(Bg_Spot16_Doughnut)
DECLARE_OVERLAY_SEGMENT(Bg_Bdan_Switch)
DECLARE_OVERLAY_SEGMENT(En_Ma1)
DECLARE_OVERLAY_SEGMENT(Boss_Ganon)
DECLARE_OVERLAY_SEGMENT(Boss_Sst)
DECLARE_OVERLAY_SEGMENT(En_Ny)
DECLARE_OVERLAY_SEGMENT(En_Fr)
DECLARE_OVERLAY_SEGMENT(Item_Shield)
DECLARE_OVERLAY_SEGMENT(Bg_Ice_Shelter)
DECLARE_OVERLAY_SEGMENT(En_Ice_Hono)
DECLARE_OVERLAY_SEGMENT(Item_Ocarina)
DECLARE_OVERLAY_SEGMENT(Magic_Dark)
DECLARE_OVERLAY_SEGMENT(Demo_6K)
DECLARE_OVERLAY_SEGMENT(En_Anubice_Tag)
DECLARE_OVERLAY_SEGMENT(Bg_Haka_Gate)
DECLARE_OVERLAY_SEGMENT(Bg_Spot15_Saku)
DECLARE_OVERLAY_SEGMENT(Bg_Jya_Goroiwa)
DECLARE_OVERLAY_SEGMENT(Bg_Jya_Zurerukabe)
DECLARE_OVERLAY_SEGMENT(Bg_Jya_Cobra)
DECLARE_OVERLAY_SEGMENT(Bg_Jya_Kanaami)
DECLARE_OVERLAY_SEGMENT(Fishing)
DECLARE_OVERLAY_SEGMENT(Obj_Oshihiki)
DECLARE_OVERLAY_SEGMENT(Bg_Gate_Shutter)
DECLARE_OVERLAY_SEGMENT(Eff_Dust)
DECLARE_OVERLAY_SEGMENT(Bg_Spot01_Fusya)
DECLARE_OVERLAY_SEGMENT(Bg_Spot01_Idohashira)
DECLARE_OVERLAY_SEGMENT(Bg_Spot01_Idomizu)
DECLARE_OVERLAY_SEGMENT(Bg_Po_Syokudai)
DECLARE_OVERLAY_SEGMENT(Bg_Ganon_Otyuka)
DECLARE_OVERLAY_SEGMENT(Bg_Spot15_Rrbox)
DECLARE_OVERLAY_SEGMENT(Bg_Umajump)
DECLARE_OVERLAY_SEGMENT(Arrow_Fire)
DECLARE_OVERLAY_SEGMENT(Arrow_Ice)
DECLARE_OVERLAY_SEGMENT(Arrow_Light)
DECLARE_OVERLAY_SEGMENT(Item_Etcetera)
DECLARE_OVERLAY_SEGMENT(Obj_Kibako)
DECLARE_OVERLAY_SEGMENT(Obj_Tsubo)
DECLARE_OVERLAY_SEGMENT(En_Wonder_Item)
DECLARE_OVERLAY_SEGMENT(En_Ik)
DECLARE_OVERLAY_SEGMENT(Demo_Ik)
DECLARE_OVERLAY_SEGMENT(En_Skj)
DECLARE_OVERLAY_SEGMENT(En_Skjneedle)
DECLARE_OVERLAY_SEGMENT(En_G_Switch)
DECLARE_OVERLAY_SEGMENT(Demo_Ext)
DECLARE_OVERLAY_SEGMENT(Demo_Shd)
DECLARE_OVERLAY_SEGMENT(En_Dns)
DECLARE_OVERLAY_SEGMENT(Elf_Msg)
DECLARE_OVERLAY_SEGMENT(En_Honotrap)
DECLARE_OVERLAY_SEGMENT(En_Tubo_Trap)
DECLARE_OVERLAY_SEGMENT(Obj_Ice_Poly)
DECLARE_OVERLAY_SEGMENT(Bg_Spot03_Taki)
DECLARE_OVERLAY_SEGMENT(Bg_Spot07_Taki)
DECLARE_OVERLAY_SEGMENT(En_Fz)
DECLARE_OVERLAY_SEGMENT(En_Po_Relay)
DECLARE_OVERLAY_SEGMENT(Bg_Relay_Objects)
DECLARE_OVERLAY_SEGMENT(En_Diving_Game)
DECLARE_OVERLAY_SEGMENT(En_Kusa)
DECLARE_OVERLAY_SEGMENT(Obj_Bean)
DECLARE_OVERLAY_SEGMENT(Obj_Bombiwa)
DECLARE_OVERLAY_SEGMENT(Obj_Switch)
DECLARE_OVERLAY_SEGMENT(Obj_Elevator)
DECLARE_OVERLAY_SEGMENT(Obj_Lift)
DECLARE_OVERLAY_SEGMENT(Obj_Hsblock)
DECLARE_OVERLAY_SEGMENT(En_Okarina_Tag)
DECLARE_OVERLAY_SEGMENT(En_Yabusame_Mark)
DECLARE_OVERLAY_SEGMENT(En_Goroiwa)
DECLARE_OVERLAY_SEGMENT(En_Ex_Ruppy)
DECLARE_OVERLAY_SEGMENT(En_Toryo)
DECLARE_OVERLAY_SEGMENT(En_Daiku)
DECLARE_OVERLAY_SEGMENT(En_Nwc)
DECLARE_OVERLAY_SEGMENT(En_Blkobj)
DECLARE_OVERLAY_SEGMENT(Item_Inbox)
DECLARE_OVERLAY_SEGMENT(En_Ge1)
DECLARE_OVERLAY_SEGMENT(Obj_Blockstop)
DECLARE_OVERLAY_SEGMENT(En_Sda)
DECLARE_OVERLAY_SEGMENT(En_Clear_Tag)
DECLARE_OVERLAY_SEGMENT(En_Niw_Lady)
DECLARE_OVERLAY_SEGMENT(En_Gm)
DECLARE_OVERLAY_SEGMENT(En_Ms)
DECLARE_OVERLAY_SEGMENT(En_Hs)
DECLARE_OVERLAY_SEGMENT(Bg_Ingate)
DECLARE_OVERLAY_SEGMENT(En_Kanban)
DECLARE_OVERLAY_SEGMENT(En_Heishi3)
DECLARE_OVERLAY_SEGMENT(En_Syateki_Niw)
DECLARE_OVERLAY_SEGMENT(En_Attack_Niw)
DECLARE_OVERLAY_SEGMENT(Bg_Spot01_Idosoko)
DECLARE_OVERLAY_SEGMENT(En_Sa)
DECLARE_OVERLAY_SEGMENT(En_Wonder_Talk)
DECLARE_OVERLAY_SEGMENT(Bg_Gjyo_Bridge)
DECLARE_OVERLAY_SEGMENT(En_Ds)
DECLARE_OVERLAY_SEGMENT(En_Mk)
DECLARE_OVERLAY_SEGMENT(En_Bom_Bowl_Man)
DECLARE_OVERLAY_SEGMENT(En_Bom_Bowl_Pit)
DECLARE_OVERLAY_SEGMENT(En_Owl)
DECLARE_OVERLAY_SEGMENT(En_Ishi)
DECLARE_OVERLAY_SEGMENT(Obj_Hana)
DECLARE_OVERLAY_SEGMENT(Obj_Lightswitch)
DECLARE_OVERLAY_SEGMENT(Obj_Mure2)
DECLARE_OVERLAY_SEGMENT(En_Go)
DECLARE_OVERLAY_SEGMENT(En_Fu)
DECLARE_OVERLAY_SEGMENT(En_Changer)
DECLARE_OVERLAY_SEGMENT(Bg_Jya_Megami)
DECLARE_OVERLAY_SEGMENT(Bg_Jya_Lift)
DECLARE_OVERLAY_SEGMENT(Bg_Jya_Bigmirror)
DECLARE_OVERLAY_SEGMENT(Bg_Jya_Bombchuiwa)
DECLARE_OVERLAY_SEGMENT(Bg_Jya_Amishutter)
DECLARE_OVERLAY_SEGMENT(Bg_Jya_Bombiwa)
DECLARE_OVERLAY_SEGMENT(Bg_Spot18_Basket)
DECLARE_OVERLAY_SEGMENT(En_Ganon_Organ)
DECLARE_OVERLAY_SEGMENT(En_Siofuki)
DECLARE_OVERLAY_SEGMENT(En_Stream)
DECLARE_OVERLAY_SEGMENT(En_Mm)
DECLARE_OVERLAY_SEGMENT(En_Ko)
DECLARE_OVERLAY_SEGMENT(En_Kz)
DECLARE_OVERLAY_SEGMENT(En_Weather_Tag)
DECLARE_OVERLAY_SEGMENT(Bg_Sst_Floor)
DECLARE_OVERLAY_SEGMENT(En_Ani)
DECLARE_OVERLAY_SEGMENT(En_Ex_Item)
DECLARE_OVERLAY_SEGMENT(Bg_Jya_Ironobj)
DECLARE_OVERLAY_SEGMENT(En_Js)
DECLARE_OVERLAY_SEGMENT(En_Jsjutan)
DECLARE_OVERLAY_SEGMENT(En_Cs)
DECLARE_OVERLAY_SEGMENT(En_Md)
DECLARE_OVERLAY_SEGMENT(En_Hy)
DECLARE_OVERLAY_SEGMENT(En_Ganon_Mant)
DECLARE_OVERLAY_SEGMENT(En_Okarina_Effect)
DECLARE_OVERLAY_SEGMENT(En_Mag)
DECLARE_OVERLAY_SEGMENT(Door_Gerudo)
DECLARE_OVERLAY_SEGMENT(Elf_Msg2)
DECLARE_OVERLAY_SEGMENT(Demo_Gt)
DECLARE_OVERLAY_SEGMENT(En_Po_Field)
DECLARE_OVERLAY_SEGMENT(Efc_Erupc)
DECLARE_OVERLAY_SEGMENT(Bg_Zg)
DECLARE_OVERLAY_SEGMENT(En_Heishi4)
DECLARE_OVERLAY_SEGMENT(En_Zl3)
DECLARE_OVERLAY_SEGMENT(Boss_Ganon2)
DECLARE_OVERLAY_SEGMENT(En_Kakasi)
DECLARE_OVERLAY_SEGMENT(En_Takara_Man)
DECLARE_OVERLAY_SEGMENT(Obj_Makeoshihiki)
DECLARE_OVERLAY_SEGMENT(Oceff_Spot)
DECLARE_OVERLAY_SEGMENT(End_Title)
DECLARE_OVERLAY_SEGMENT(En_Torch)
DECLARE_OVERLAY_SEGMENT(Demo_Ec)
DECLARE_OVERLAY_SEGMENT(Shot_Sun)
DECLARE_OVERLAY_SEGMENT(En_Dy_Extra)
DECLARE_OVERLAY_SEGMENT(En_Wonder_Talk2)
DECLARE_OVERLAY_SEGMENT(En_Ge2)
DECLARE_OVERLAY_SEGMENT(Obj_Roomtimer)
DECLARE_OVERLAY_SEGMENT(En_Ssh)
DECLARE_OVERLAY_SEGMENT(En_Sth)
DECLARE_OVERLAY_SEGMENT(Oceff_Wipe)
DECLARE_OVERLAY_SEGMENT(Oceff_Storm)
DECLARE_OVERLAY_SEGMENT(En_Weiyer)
DECLARE_OVERLAY_SEGMENT(Bg_Spot05_Soko)
DECLARE_OVERLAY_SEGMENT(Bg_Jya_1flift)
DECLARE_OVERLAY_SEGMENT(Bg_Jya_Haheniron)
DECLARE_OVERLAY_SEGMENT(Bg_Spot12_Gate)
DECLARE_OVERLAY_SEGMENT(Bg_Spot12_Saku)
DECLARE_OVERLAY_SEGMENT(En_Hintnuts)
DECLARE_OVERLAY_SEGMENT(En_Nutsball)
DECLARE_OVERLAY_SEGMENT(Bg_Spot00_Break)
DECLARE_OVERLAY_SEGMENT(En_Shopnuts)
DECLARE_OVERLAY_SEGMENT(En_It)
DECLARE_OVERLAY_SEGMENT(En_GeldB)
DECLARE_OVERLAY_SEGMENT(Oceff_Wipe2)
DECLARE_OVERLAY_SEGMENT(Oceff_Wipe3)
DECLARE_OVERLAY_SEGMENT(En_Niw_Girl)
DECLARE_OVERLAY_SEGMENT(En_Dog)
DECLARE_OVERLAY_SEGMENT(En_Si)
DECLARE_OVERLAY_SEGMENT(Bg_Spot01_Objects2)
DECLARE_OVERLAY_SEGMENT(Obj_Comb)
DECLARE_OVERLAY_SEGMENT(Bg_Spot11_Bakudankabe)
DECLARE_OVERLAY_SEGMENT(Obj_Kibako2)
DECLARE_OVERLAY_SEGMENT(En_Dnt_Demo)
DECLARE_OVERLAY_SEGMENT(En_Dnt_Jiji)
DECLARE_OVERLAY_SEGMENT(En_Dnt_Nomal)
DECLARE_OVERLAY_SEGMENT(En_Guest)
DECLARE_OVERLAY_SEGMENT(Bg_Bom_Guard)
DECLARE_OVERLAY_SEGMENT(En_Hs2)
DECLARE_OVERLAY_SEGMENT(Demo_Kekkai)
DECLARE_OVERLAY_SEGMENT(Bg_Spot08_Bakudankabe)
DECLARE_OVERLAY_SEGMENT(Bg_Spot17_Bakudankabe)
DECLARE_OVERLAY_SEGMENT(Obj_Mure3)
DECLARE_OVERLAY_SEGMENT(En_Tg)
DECLARE_OVERLAY_SEGMENT(En_Mu)
DECLARE_OVERLAY_SEGMENT(En_Go2)
DECLARE_OVERLAY_SEGMENT(En_Wf)
DECLARE_OVERLAY_SEGMENT(En_Skb)
DECLARE_OVERLAY_SEGMENT(Demo_Gj)
DECLARE_OVERLAY_SEGMENT(Demo_Geff)
DECLARE_OVERLAY_SEGMENT(Bg_Gnd_Firemeiro)
DECLARE_OVERLAY_SEGMENT(Bg_Gnd_Darkmeiro)
DECLARE_OVERLAY_SEGMENT(Bg_Gnd_Soulmeiro)
DECLARE_OVERLAY_SEGMENT(Bg_Gnd_Nisekabe)
DECLARE_OVERLAY_SEGMENT(Bg_Gnd_Iceblock)
DECLARE_OVERLAY_SEGMENT(En_Gb)
DECLARE_OVERLAY_SEGMENT(En_Gs)
DECLARE_OVERLAY_SEGMENT(Bg_Mizu_Bwall)
DECLARE_OVERLAY_SEGMENT(Bg_Mizu_Shutter)
DECLARE_OVERLAY_SEGMENT(En_Daiku_Kakariko)
DECLARE_OVERLAY_SEGMENT(Bg_Bowl_Wall)
DECLARE_OVERLAY_SEGMENT(En_Wall_Tubo)
DECLARE_OVERLAY_SEGMENT(En_Po_Desert)
DECLARE_OVERLAY_SEGMENT(En_Crow)
DECLARE_OVERLAY_SEGMENT(Door_Killer)
DECLARE_OVERLAY_SEGMENT(Bg_Spot11_Oasis)
DECLARE_OVERLAY_SEGMENT(Bg_Spot18_Futa)
DECLARE_OVERLAY_SEGMENT(Bg_Spot18_Shutter)
DECLARE_OVERLAY_SEGMENT(En_Ma3)
DECLARE_OVERLAY_SEGMENT(En_Cow)
DECLARE_OVERLAY_SEGMENT(Bg_Ice_Turara)
DECLARE_OVERLAY_SEGMENT(Bg_Ice_Shutter)
DECLARE_OVERLAY_SEGMENT(En_Kakasi2)
DECLARE_OVERLAY_SEGMENT(En_Kakasi3)
DECLARE_OVERLAY_SEGMENT(Oceff_Wipe4)
DECLARE_OVERLAY_SEGMENT(En_Eg)
DECLARE_OVERLAY_SEGMENT(Bg_Menkuri_Nisekabe)
DECLARE_OVERLAY_SEGMENT(En_Zo)
DECLARE_OVERLAY_SEGMENT(Obj_Makekinsuta)
DECLARE_OVERLAY_SEGMENT(En_Ge3)
DECLARE_OVERLAY_SEGMENT(Obj_Timeblock)
DECLARE_OVERLAY_SEGMENT(Obj_Hamishi)
DECLARE_OVERLAY_SEGMENT(En_Zl4)
DECLARE_OVERLAY_SEGMENT(En_Mm2)
DECLARE_OVERLAY_SEGMENT(Bg_Jya_Block)
DECLARE_OVERLAY_SEGMENT(Obj_Warp2block)

DECLARE_ROM_SEGMENT(gameplay_keep)
DECLARE_ROM_SEGMENT(gameplay_field_keep)
DECLARE_ROM_SEGMENT(gameplay_dangeon_keep)
DECLARE_ROM_SEGMENT(object_human)
DECLARE_ROM_SEGMENT(object_okuta)
DECLARE_ROM_SEGMENT(object_crow)
DECLARE_ROM_SEGMENT(object_poh)
DECLARE_ROM_SEGMENT(object_dy_obj)
DECLARE_ROM_SEGMENT(object_wallmaster)
DECLARE_ROM_SEGMENT(object_dodongo)
DECLARE_ROM_SEGMENT(object_firefly)
DECLARE_ROM_SEGMENT(object_box)
DECLARE_ROM_SEGMENT(object_fire)
DECLARE_ROM_SEGMENT(object_bubble)
DECLARE_ROM_SEGMENT(object_niw)
DECLARE_ROM_SEGMENT(object_link_boy)
DECLARE_ROM_SEGMENT(object_link_child)
DECLARE_ROM_SEGMENT(object_tite)
DECLARE_ROM_SEGMENT(object_reeba)
DECLARE_ROM_SEGMENT(object_peehat)
DECLARE_ROM_SEGMENT(object_kingdodongo)
DECLARE_ROM_SEGMENT(object_horse)
DECLARE_ROM_SEGMENT(object_zf)
DECLARE_ROM_SEGMENT(object_goma)
DECLARE_ROM_SEGMENT(object_zl1)
DECLARE_ROM_SEGMENT(object_gol)
DECLARE_ROM_SEGMENT(object_dodojr)
DECLARE_ROM_SEGMENT(object_torch2)
DECLARE_ROM_SEGMENT(object_bl)
DECLARE_ROM_SEGMENT(object_tp)
DECLARE_ROM_SEGMENT(object_oA1)
DECLARE_ROM_SEGMENT(object_st)
DECLARE_ROM_SEGMENT(object_bw)
DECLARE_ROM_SEGMENT(object_ei)
DECLARE_ROM_SEGMENT(object_horse_normal)
DECLARE_ROM_SEGMENT(object_oB1)
DECLARE_ROM_SEGMENT(object_o_anime)
DECLARE_ROM_SEGMENT(object_spot04_objects)
DECLARE_ROM_SEGMENT(object_ddan_objects)
DECLARE_ROM_SEGMENT(object_hidan_objects)
DECLARE_ROM_SEGMENT(object_horse_ganon)
DECLARE_ROM_SEGMENT(object_oA2)
DECLARE_ROM_SEGMENT(object_spot00_objects)
DECLARE_ROM_SEGMENT(object_mb)
DECLARE_ROM_SEGMENT(object_bombf)
DECLARE_ROM_SEGMENT(object_sk2)
DECLARE_ROM_SEGMENT(object_oE1)
DECLARE_ROM_SEGMENT(object_oE_anime)
DECLARE_ROM_SEGMENT(object_oE2)
DECLARE_ROM_SEGMENT(object_ydan_objects)
DECLARE_ROM_SEGMENT(object_gnd)
DECLARE_ROM_SEGMENT(object_am)
DECLARE_ROM_SEGMENT(object_dekubaba)
DECLARE_ROM_SEGMENT(object_oA3)
DECLARE_ROM_SEGMENT(object_oA4)
DECLARE_ROM_SEGMENT(object_oA5)
DECLARE_ROM_SEGMENT(object_oA6)
DECLARE_ROM_SEGMENT(object_oA7)
DECLARE_ROM_SEGMENT(object_jj)
DECLARE_ROM_SEGMENT(object_oA8)
DECLARE_ROM_SEGMENT(object_oA9)
DECLARE_ROM_SEGMENT(object_oB2)
DECLARE_ROM_SEGMENT(object_oB3)
DECLARE_ROM_SEGMENT(object_oB4)
DECLARE_ROM_SEGMENT(object_horse_zelda)
DECLARE_ROM_SEGMENT(object_opening_demo1)
DECLARE_ROM_SEGMENT(object_warp1)
DECLARE_ROM_SEGMENT(object_b_heart)
DECLARE_ROM_SEGMENT(object_dekunuts)
DECLARE_ROM_SEGMENT(object_oE3)
DECLARE_ROM_SEGMENT(object_oE4)
DECLARE_ROM_SEGMENT(object_menkuri_objects)
DECLARE_ROM_SEGMENT(object_oE5)
DECLARE_ROM_SEGMENT(object_oE6)
DECLARE_ROM_SEGMENT(object_oE7)
DECLARE_ROM_SEGMENT(object_oE8)
DECLARE_ROM_SEGMENT(object_oE9)
DECLARE_ROM_SEGMENT(object_oE10)
DECLARE_ROM_SEGMENT(object_oE11)
DECLARE_ROM_SEGMENT(object_oE12)
DECLARE_ROM_SEGMENT(object_vali)
DECLARE_ROM_SEGMENT(object_oA10)
DECLARE_ROM_SEGMENT(object_oA11)
DECLARE_ROM_SEGMENT(object_mizu_objects)
DECLARE_ROM_SEGMENT(object_fhg)
DECLARE_ROM_SEGMENT(object_ossan)
DECLARE_ROM_SEGMENT(object_mori_hineri1)
DECLARE_ROM_SEGMENT(object_Bb)
DECLARE_ROM_SEGMENT(object_toki_objects)
DECLARE_ROM_SEGMENT(object_yukabyun)
DECLARE_ROM_SEGMENT(object_zl2)
DECLARE_ROM_SEGMENT(object_mjin)
DECLARE_ROM_SEGMENT(object_mjin_flash)
DECLARE_ROM_SEGMENT(object_mjin_dark)
DECLARE_ROM_SEGMENT(object_mjin_flame)
DECLARE_ROM_SEGMENT(object_mjin_ice)
DECLARE_ROM_SEGMENT(object_mjin_soul)
DECLARE_ROM_SEGMENT(object_mjin_wind)
DECLARE_ROM_SEGMENT(object_mjin_oka)
DECLARE_ROM_SEGMENT(object_haka_objects)
DECLARE_ROM_SEGMENT(object_spot06_objects)
DECLARE_ROM_SEGMENT(object_ice_objects)
DECLARE_ROM_SEGMENT(object_relay_objects)
DECLARE_ROM_SEGMENT(object_po_field)
DECLARE_ROM_SEGMENT(object_po_composer)
DECLARE_ROM_SEGMENT(object_mori_hineri1a)
DECLARE_ROM_SEGMENT(object_mori_hineri2)
DECLARE_ROM_SEGMENT(object_mori_hineri2a)
DECLARE_ROM_SEGMENT(object_mori_objects)
DECLARE_ROM_SEGMENT(object_mori_tex)
DECLARE_ROM_SEGMENT(object_spot08_obj)
DECLARE_ROM_SEGMENT(object_warp2)
DECLARE_ROM_SEGMENT(object_hata)
DECLARE_ROM_SEGMENT(object_bird)
DECLARE_ROM_SEGMENT(object_wood02)
DECLARE_ROM_SEGMENT(object_lightbox)
DECLARE_ROM_SEGMENT(object_pu_box)
DECLARE_ROM_SEGMENT(object_trap)
DECLARE_ROM_SEGMENT(object_vase)
DECLARE_ROM_SEGMENT(object_im)
DECLARE_ROM_SEGMENT(object_ta)
DECLARE_ROM_SEGMENT(object_tk)
DECLARE_ROM_SEGMENT(object_xc)
DECLARE_ROM_SEGMENT(object_vm)
DECLARE_ROM_SEGMENT(object_bv)
DECLARE_ROM_SEGMENT(object_hakach_objects)
DECLARE_ROM_SEGMENT(object_efc_crystal_light)
DECLARE_ROM_SEGMENT(object_efc_fire_ball)
DECLARE_ROM_SEGMENT(object_efc_flash)
DECLARE_ROM_SEGMENT(object_efc_lgt_shower)
DECLARE_ROM_SEGMENT(object_efc_star_field)
DECLARE_ROM_SEGMENT(object_god_lgt)
DECLARE_ROM_SEGMENT(object_light_ring)
DECLARE_ROM_SEGMENT(object_triforce_spot)
DECLARE_ROM_SEGMENT(object_bdan_objects)
DECLARE_ROM_SEGMENT(object_sd)
DECLARE_ROM_SEGMENT(object_rd)
DECLARE_ROM_SEGMENT(object_po_sisters)
DECLARE_ROM_SEGMENT(object_heavy_object)
DECLARE_ROM_SEGMENT(object_gndd)
DECLARE_ROM_SEGMENT(object_fd)
DECLARE_ROM_SEGMENT(object_du)
DECLARE_ROM_SEGMENT(object_fw)
DECLARE_ROM_SEGMENT(object_medal)
DECLARE_ROM_SEGMENT(object_horse_link_child)
DECLARE_ROM_SEGMENT(object_spot02_objects)
DECLARE_ROM_SEGMENT(object_haka)
DECLARE_ROM_SEGMENT(object_ru1)
DECLARE_ROM_SEGMENT(object_syokudai)
DECLARE_ROM_SEGMENT(object_fd2)
DECLARE_ROM_SEGMENT(object_dh)
DECLARE_ROM_SEGMENT(object_rl)
DECLARE_ROM_SEGMENT(object_efc_tw)
DECLARE_ROM_SEGMENT(object_demo_tre_lgt)
DECLARE_ROM_SEGMENT(object_gi_key)
DECLARE_ROM_SEGMENT(object_mir_ray)
DECLARE_ROM_SEGMENT(object_brob)
DECLARE_ROM_SEGMENT(object_gi_jewel)
DECLARE_ROM_SEGMENT(object_spot09_obj)
DECLARE_ROM_SEGMENT(object_spot18_obj)
DECLARE_ROM_SEGMENT(object_bdoor)
DECLARE_ROM_SEGMENT(object_spot17_obj)
DECLARE_ROM_SEGMENT(object_shop_dungen)
DECLARE_ROM_SEGMENT(object_nb)
DECLARE_ROM_SEGMENT(object_mo)
DECLARE_ROM_SEGMENT(object_sb)
DECLARE_ROM_SEGMENT(object_gi_melody)
DECLARE_ROM_SEGMENT(object_gi_heart)
DECLARE_ROM_SEGMENT(object_gi_compass)
DECLARE_ROM_SEGMENT(object_gi_bosskey)
DECLARE_ROM_SEGMENT(object_gi_medal)
DECLARE_ROM_SEGMENT(object_gi_nuts)
DECLARE_ROM_SEGMENT(object_sa)
DECLARE_ROM_SEGMENT(object_gi_hearts)
DECLARE_ROM_SEGMENT(object_gi_arrowcase)
DECLARE_ROM_SEGMENT(object_gi_bombpouch)
DECLARE_ROM_SEGMENT(object_in)
DECLARE_ROM_SEGMENT(object_tr)
DECLARE_ROM_SEGMENT(object_spot16_obj)
DECLARE_ROM_SEGMENT(object_oE1s)
DECLARE_ROM_SEGMENT(object_oE4s)
DECLARE_ROM_SEGMENT(object_os_anime)
DECLARE_ROM_SEGMENT(object_gi_bottle)
DECLARE_ROM_SEGMENT(object_gi_stick)
DECLARE_ROM_SEGMENT(object_gi_map)
DECLARE_ROM_SEGMENT(object_oF1d_map)
DECLARE_ROM_SEGMENT(object_ru2)
DECLARE_ROM_SEGMENT(object_gi_shield_1)
DECLARE_ROM_SEGMENT(object_dekujr)
DECLARE_ROM_SEGMENT(object_gi_magicpot)
DECLARE_ROM_SEGMENT(object_gi_bomb_1)
DECLARE_ROM_SEGMENT(object_oF1s)
DECLARE_ROM_SEGMENT(object_ma2)
DECLARE_ROM_SEGMENT(object_gi_purse)
DECLARE_ROM_SEGMENT(object_hni)
DECLARE_ROM_SEGMENT(object_tw)
DECLARE_ROM_SEGMENT(object_rr)
DECLARE_ROM_SEGMENT(object_bxa)
DECLARE_ROM_SEGMENT(object_anubice)
DECLARE_ROM_SEGMENT(object_gi_gerudo)
DECLARE_ROM_SEGMENT(object_gi_arrow)
DECLARE_ROM_SEGMENT(object_gi_bomb_2)
DECLARE_ROM_SEGMENT(object_gi_egg)
DECLARE_ROM_SEGMENT(object_gi_scale)
DECLARE_ROM_SEGMENT(object_gi_shield_2)
DECLARE_ROM_SEGMENT(object_gi_hookshot)
DECLARE_ROM_SEGMENT(object_gi_ocarina)
DECLARE_ROM_SEGMENT(object_gi_milk)
DECLARE_ROM_SEGMENT(object_ma1)
DECLARE_ROM_SEGMENT(object_ganon)
DECLARE_ROM_SEGMENT(object_sst)
DECLARE_ROM_SEGMENT(object_ny)
DECLARE_ROM_SEGMENT(object_ny)
DECLARE_ROM_SEGMENT(object_fr)
DECLARE_ROM_SEGMENT(object_gi_pachinko)
DECLARE_ROM_SEGMENT(object_gi_boomerang)
DECLARE_ROM_SEGMENT(object_gi_bow)
DECLARE_ROM_SEGMENT(object_gi_glasses)
DECLARE_ROM_SEGMENT(object_gi_liquid)
DECLARE_ROM_SEGMENT(object_ani)
DECLARE_ROM_SEGMENT(object_demo_6k)
DECLARE_ROM_SEGMENT(object_gi_shield_3)
DECLARE_ROM_SEGMENT(object_gi_letter)
DECLARE_ROM_SEGMENT(object_spot15_obj)
DECLARE_ROM_SEGMENT(object_jya_obj)
DECLARE_ROM_SEGMENT(object_gi_clothes)
DECLARE_ROM_SEGMENT(object_gi_bean)
DECLARE_ROM_SEGMENT(object_gi_fish)
DECLARE_ROM_SEGMENT(object_gi_saw)
DECLARE_ROM_SEGMENT(object_gi_hammer)
DECLARE_ROM_SEGMENT(object_gi_grass)
DECLARE_ROM_SEGMENT(object_gi_longsword)
DECLARE_ROM_SEGMENT(object_spot01_objects)
DECLARE_ROM_SEGMENT(object_md)
DECLARE_ROM_SEGMENT(object_md)
DECLARE_ROM_SEGMENT(object_km1)
DECLARE_ROM_SEGMENT(object_kw1)
DECLARE_ROM_SEGMENT(object_zo)
DECLARE_ROM_SEGMENT(object_kz)
DECLARE_ROM_SEGMENT(object_umajump)
DECLARE_ROM_SEGMENT(object_masterkokiri)
DECLARE_ROM_SEGMENT(object_masterkokirihead)
DECLARE_ROM_SEGMENT(object_mastergolon)
DECLARE_ROM_SEGMENT(object_masterzoora)
DECLARE_ROM_SEGMENT(object_aob)
DECLARE_ROM_SEGMENT(object_ik)
DECLARE_ROM_SEGMENT(object_ahg)
DECLARE_ROM_SEGMENT(object_cne)
DECLARE_ROM_SEGMENT(object_gi_niwatori)
DECLARE_ROM_SEGMENT(object_skj)
DECLARE_ROM_SEGMENT(object_gi_bottle_letter)
DECLARE_ROM_SEGMENT(object_bji)
DECLARE_ROM_SEGMENT(object_bba)
DECLARE_ROM_SEGMENT(object_gi_ocarina_0)
DECLARE_ROM_SEGMENT(object_ds)
DECLARE_ROM_SEGMENT(object_ane)
DECLARE_ROM_SEGMENT(object_boj)
DECLARE_ROM_SEGMENT(object_spot03_object)
DECLARE_ROM_SEGMENT(object_spot07_object)
DECLARE_ROM_SEGMENT(object_fz)
DECLARE_ROM_SEGMENT(object_bob)
DECLARE_ROM_SEGMENT(object_ge1)
DECLARE_ROM_SEGMENT(object_yabusame_point)
DECLARE_ROM_SEGMENT(object_gi_boots_2)
DECLARE_ROM_SEGMENT(object_gi_seed)
DECLARE_ROM_SEGMENT(object_gnd_magic)
DECLARE_ROM_SEGMENT(object_d_elevator)
DECLARE_ROM_SEGMENT(object_d_hsblock)
DECLARE_ROM_SEGMENT(object_d_lift)
DECLARE_ROM_SEGMENT(object_mamenoki)
DECLARE_ROM_SEGMENT(object_goroiwa)
DECLARE_ROM_SEGMENT(object_toryo)
DECLARE_ROM_SEGMENT(object_daiku)
DECLARE_ROM_SEGMENT(object_nwc)
DECLARE_ROM_SEGMENT(object_blkobj)
DECLARE_ROM_SEGMENT(object_gm)
DECLARE_ROM_SEGMENT(object_ms)
DECLARE_ROM_SEGMENT(object_hs)
DECLARE_ROM_SEGMENT(object_ingate)
DECLARE_ROM_SEGMENT(object_lightswitch)
DECLARE_ROM_SEGMENT(object_kusa)
DECLARE_ROM_SEGMENT(object_tsubo)
DECLARE_ROM_SEGMENT(object_gi_gloves)
DECLARE_ROM_SEGMENT(object_gi_coin)
DECLARE_ROM_SEGMENT(object_kanban)
DECLARE_ROM_SEGMENT(object_gjyo_objects)
DECLARE_ROM_SEGMENT(object_owl)
DECLARE_ROM_SEGMENT(object_mk)
DECLARE_ROM_SEGMENT(object_fu)
DECLARE_ROM_SEGMENT(object_gi_ki_tan_mask)
DECLARE_ROM_SEGMENT(object_gi_redead_mask)
DECLARE_ROM_SEGMENT(object_gi_skj_mask)
DECLARE_ROM_SEGMENT(object_gi_rabit_mask)
DECLARE_ROM_SEGMENT(object_gi_truth_mask)
DECLARE_ROM_SEGMENT(object_ganon_objects)
DECLARE_ROM_SEGMENT(object_siofuki)
DECLARE_ROM_SEGMENT(object_stream)
DECLARE_ROM_SEGMENT(object_mm)
DECLARE_ROM_SEGMENT(object_fa)
DECLARE_ROM_SEGMENT(object_os)
DECLARE_ROM_SEGMENT(object_gi_eye_lotion)
DECLARE_ROM_SEGMENT(object_gi_powder)
DECLARE_ROM_SEGMENT(object_gi_mushroom)
DECLARE_ROM_SEGMENT(object_gi_ticketstone)
DECLARE_ROM_SEGMENT(object_gi_brokensword)
DECLARE_ROM_SEGMENT(object_js)
DECLARE_ROM_SEGMENT(object_cs)
DECLARE_ROM_SEGMENT(object_gi_prescription)
DECLARE_ROM_SEGMENT(object_gi_bracelet)
DECLARE_ROM_SEGMENT(object_gi_soldout)
DECLARE_ROM_SEGMENT(object_gi_frog)
DECLARE_ROM_SEGMENT(object_mag)
DECLARE_ROM_SEGMENT(object_door_gerudo)
DECLARE_ROM_SEGMENT(object_gt)
DECLARE_ROM_SEGMENT(object_efc_erupc)
DECLARE_ROM_SEGMENT(object_zl2_anime1)
DECLARE_ROM_SEGMENT(object_zl2_anime2)
DECLARE_ROM_SEGMENT(object_gi_golonmask)
DECLARE_ROM_SEGMENT(object_gi_zoramask)
DECLARE_ROM_SEGMENT(object_gi_gerudomask)
DECLARE_ROM_SEGMENT(object_ganon2)
DECLARE_ROM_SEGMENT(object_ka)
DECLARE_ROM_SEGMENT(object_ts)
DECLARE_ROM_SEGMENT(object_zg)
DECLARE_ROM_SEGMENT(object_gi_hoverboots)
DECLARE_ROM_SEGMENT(object_gi_m_arrow)
DECLARE_ROM_SEGMENT(object_ds2)
DECLARE_ROM_SEGMENT(object_ec)
DECLARE_ROM_SEGMENT(object_fish)
DECLARE_ROM_SEGMENT(object_gi_sutaru)
DECLARE_ROM_SEGMENT(object_gi_goddess)
DECLARE_ROM_SEGMENT(object_ssh)
DECLARE_ROM_SEGMENT(object_bigokuta)
DECLARE_ROM_SEGMENT(object_bg)
DECLARE_ROM_SEGMENT(object_spot05_objects)
DECLARE_ROM_SEGMENT(object_spot12_obj)
DECLARE_ROM_SEGMENT(object_bombiwa)
DECLARE_ROM_SEGMENT(object_hintnuts)
DECLARE_ROM_SEGMENT(object_rs)
DECLARE_ROM_SEGMENT(object_spot00_break)
DECLARE_ROM_SEGMENT(object_gla)
DECLARE_ROM_SEGMENT(object_shopnuts)
DECLARE_ROM_SEGMENT(object_geldb)
DECLARE_ROM_SEGMENT(object_gr)
DECLARE_ROM_SEGMENT(object_dog)
DECLARE_ROM_SEGMENT(object_jya_iron)
DECLARE_ROM_SEGMENT(object_jya_door)
DECLARE_ROM_SEGMENT(object_spot11_obj)
DECLARE_ROM_SEGMENT(object_kibako2)
DECLARE_ROM_SEGMENT(object_dns)
DECLARE_ROM_SEGMENT(object_dnk)
DECLARE_ROM_SEGMENT(object_gi_fire)
DECLARE_ROM_SEGMENT(object_gi_insect)
DECLARE_ROM_SEGMENT(object_gi_butterfly)
DECLARE_ROM_SEGMENT(object_gi_ghost)
DECLARE_ROM_SEGMENT(object_gi_soul)
DECLARE_ROM_SEGMENT(object_bowl)
DECLARE_ROM_SEGMENT(object_demo_kekkai)
DECLARE_ROM_SEGMENT(object_efc_doughnut)
DECLARE_ROM_SEGMENT(object_gi_dekupouch)
DECLARE_ROM_SEGMENT(object_ganon_anime1)
DECLARE_ROM_SEGMENT(object_ganon_anime2)
DECLARE_ROM_SEGMENT(object_ganon_anime3)
DECLARE_ROM_SEGMENT(object_gi_rupy)
DECLARE_ROM_SEGMENT(object_spot01_matoya)
DECLARE_ROM_SEGMENT(object_spot01_matoyab)
DECLARE_ROM_SEGMENT(object_mu)
DECLARE_ROM_SEGMENT(object_wf)
DECLARE_ROM_SEGMENT(object_skb)
DECLARE_ROM_SEGMENT(object_gj)
DECLARE_ROM_SEGMENT(object_geff)
DECLARE_ROM_SEGMENT(object_haka_door)
DECLARE_ROM_SEGMENT(object_gs)
DECLARE_ROM_SEGMENT(object_ps)
DECLARE_ROM_SEGMENT(object_bwall)
DECLARE_ROM_SEGMENT(object_cow)
DECLARE_ROM_SEGMENT(object_cob)
DECLARE_ROM_SEGMENT(object_gi_sword_1)
DECLARE_ROM_SEGMENT(object_door_killer)
DECLARE_ROM_SEGMENT(object_ouke_haka)
DECLARE_ROM_SEGMENT(object_timeblock)
DECLARE_ROM_SEGMENT(object_zl4)

DECLARE_ROM_SEGMENT(g_pn_01)
DECLARE_ROM_SEGMENT(g_pn_02)
DECLARE_ROM_SEGMENT(g_pn_03)
DECLARE_ROM_SEGMENT(g_pn_04)
DECLARE_ROM_SEGMENT(g_pn_05)
DECLARE_ROM_SEGMENT(g_pn_06)
DECLARE_ROM_SEGMENT(g_pn_07)
DECLARE_ROM_SEGMENT(g_pn_08)
DECLARE_ROM_SEGMENT(g_pn_09)
DECLARE_ROM_SEGMENT(g_pn_10)
DECLARE_ROM_SEGMENT(g_pn_11)
DECLARE_ROM_SEGMENT(g_pn_12)
DECLARE_ROM_SEGMENT(g_pn_13)
DECLARE_ROM_SEGMENT(g_pn_14)
DECLARE_ROM_SEGMENT(g_pn_15)
DECLARE_ROM_SEGMENT(g_pn_16)
DECLARE_ROM_SEGMENT(g_pn_17)
DECLARE_ROM_SEGMENT(g_pn_18)
DECLARE_ROM_SEGMENT(g_pn_19)
DECLARE_ROM_SEGMENT(g_pn_20)
DECLARE_ROM_SEGMENT(g_pn_21)
DECLARE_ROM_SEGMENT(g_pn_22)
DECLARE_ROM_SEGMENT(g_pn_23)
DECLARE_ROM_SEGMENT(g_pn_24)
DECLARE_ROM_SEGMENT(g_pn_25)
DECLARE_ROM_SEGMENT(g_pn_26)
DECLARE_ROM_SEGMENT(g_pn_27)
DECLARE_ROM_SEGMENT(g_pn_28)
DECLARE_ROM_SEGMENT(g_pn_29)
DECLARE_ROM_SEGMENT(g_pn_30)
DECLARE_ROM_SEGMENT(g_pn_31)
DECLARE_ROM_SEGMENT(g_pn_32)
DECLARE_ROM_SEGMENT(g_pn_33)
DECLARE_ROM_SEGMENT(g_pn_34)
DECLARE_ROM_SEGMENT(g_pn_35)
DECLARE_ROM_SEGMENT(g_pn_36)
DECLARE_ROM_SEGMENT(g_pn_37)
DECLARE_ROM_SEGMENT(g_pn_38)
DECLARE_ROM_SEGMENT(g_pn_39)
DECLARE_ROM_SEGMENT(g_pn_40)
DECLARE_ROM_SEGMENT(g_pn_41)
DECLARE_ROM_SEGMENT(g_pn_42)
DECLARE_ROM_SEGMENT(g_pn_43)
DECLARE_ROM_SEGMENT(g_pn_44)
DECLARE_ROM_SEGMENT(g_pn_45)
DECLARE_ROM_SEGMENT(g_pn_46)
DECLARE_ROM_SEGMENT(g_pn_47)
DECLARE_ROM_SEGMENT(g_pn_48)
DECLARE_ROM_SEGMENT(g_pn_49)
DECLARE_ROM_SEGMENT(g_pn_50)
DECLARE_ROM_SEGMENT(g_pn_51)
DECLARE_ROM_SEGMENT(g_pn_52)
DECLARE_ROM_SEGMENT(g_pn_53)
DECLARE_ROM_SEGMENT(g_pn_54)
DECLARE_ROM_SEGMENT(g_pn_55)
DECLARE_ROM_SEGMENT(g_pn_56)
DECLARE_ROM_SEGMENT(g_pn_57)

DECLARE_ROM_SEGMENT(z_select_static)
DECLARE_ROM_SEGMENT(nintendo_rogo_static)
DECLARE_ROM_SEGMENT(title_static)
DECLARE_ROM_SEGMENT(parameter_static)
DECLARE_ROM_SEGMENT(vr_fine0_static)
DECLARE_ROM_SEGMENT(vr_fine0_pal_static)
DECLARE_ROM_SEGMENT(vr_fine1_static)
DECLARE_ROM_SEGMENT(vr_fine1_pal_static)
DECLARE_ROM_SEGMENT(vr_fine2_static)
DECLARE_ROM_SEGMENT(vr_fine2_pal_static)
DECLARE_ROM_SEGMENT(vr_fine3_static)
DECLARE_ROM_SEGMENT(vr_fine3_pal_static)
DECLARE_ROM_SEGMENT(vr_cloud0_static)
DECLARE_ROM_SEGMENT(vr_cloud0_pal_static)
DECLARE_ROM_SEGMENT(vr_cloud1_static)
DECLARE_ROM_SEGMENT(vr_cloud1_pal_static)
DECLARE_ROM_SEGMENT(vr_cloud2_static)
DECLARE_ROM_SEGMENT(vr_cloud2_pal_static)
DECLARE_ROM_SEGMENT(vr_cloud3_static)
DECLARE_ROM_SEGMENT(vr_cloud3_pal_static)
DECLARE_ROM_SEGMENT(vr_holy0_static)
DECLARE_ROM_SEGMENT(vr_holy0_pal_static)
DECLARE_ROM_SEGMENT(vr_holy1_static)
DECLARE_ROM_SEGMENT(vr_holy1_pal_static)
DECLARE_ROM_SEGMENT(vr_MDVR_static)
DECLARE_ROM_SEGMENT(vr_MDVR_pal_static)
DECLARE_ROM_SEGMENT(vr_MNVR_static)
DECLARE_ROM_SEGMENT(vr_MNVR_pal_static)
DECLARE_ROM_SEGMENT(vr_RUVR_static)
DECLARE_ROM_SEGMENT(vr_RUVR_pal_static)
DECLARE_ROM_SEGMENT(vr_LHVR_static)
DECLARE_ROM_SEGMENT(vr_KHVR_static)
DECLARE_ROM_SEGMENT(vr_K3VR_static)
DECLARE_ROM_SEGMENT(vr_K4VR_static)
DECLARE_ROM_SEGMENT(vr_K5VR_static)
DECLARE_ROM_SEGMENT(vr_SP1a_static)
DECLARE_ROM_SEGMENT(vr_MLVR_static)
DECLARE_ROM_SEGMENT(vr_KKRVR_static)
DECLARE_ROM_SEGMENT(vr_KR3VR_static)
DECLARE_ROM_SEGMENT(vr_IPVR_static)
DECLARE_ROM_SEGMENT(vr_KSVR_static)
DECLARE_ROM_SEGMENT(vr_GLVR_static)
DECLARE_ROM_SEGMENT(vr_ZRVR_static)
DECLARE_ROM_SEGMENT(vr_DGVR_static)
DECLARE_ROM_SEGMENT(vr_ALVR_static)
DECLARE_ROM_SEGMENT(vr_NSVR_static)
DECLARE_ROM_SEGMENT(vr_LBVR_static)
DECLARE_ROM_SEGMENT(vr_TTVR_static)
DECLARE_ROM_SEGMENT(vr_FCVR_static)
DECLARE_ROM_SEGMENT(elf_message_field)
DECLARE_ROM_SEGMENT(elf_message_ydan)

// SCENES AND ROOMS
DECLARE_ROM_SEGMENT(ydan_scene)
DECLARE_ROM_SEGMENT(ydan_room_0)
DECLARE_ROM_SEGMENT(ydan_room_1)
DECLARE_ROM_SEGMENT(ydan_room_2)
DECLARE_ROM_SEGMENT(ydan_room_3)
DECLARE_ROM_SEGMENT(ydan_room_4)
DECLARE_ROM_SEGMENT(ydan_room_5)
DECLARE_ROM_SEGMENT(ydan_room_6)
DECLARE_ROM_SEGMENT(ydan_room_7)
DECLARE_ROM_SEGMENT(ydan_room_8)
DECLARE_ROM_SEGMENT(ydan_room_9)
DECLARE_ROM_SEGMENT(ydan_room_10)
DECLARE_ROM_SEGMENT(ydan_room_11)

DECLARE_ROM_SEGMENT(ddan_scene)
DECLARE_ROM_SEGMENT(ddan_room_0)
DECLARE_ROM_SEGMENT(ddan_room_1)
DECLARE_ROM_SEGMENT(ddan_room_2)
DECLARE_ROM_SEGMENT(ddan_room_3)
DECLARE_ROM_SEGMENT(ddan_room_4)
DECLARE_ROM_SEGMENT(ddan_room_5)
DECLARE_ROM_SEGMENT(ddan_room_6)
DECLARE_ROM_SEGMENT(ddan_room_7)
DECLARE_ROM_SEGMENT(ddan_room_8)
DECLARE_ROM_SEGMENT(ddan_room_9)
DECLARE_ROM_SEGMENT(ddan_room_10)
DECLARE_ROM_SEGMENT(ddan_room_11)
DECLARE_ROM_SEGMENT(ddan_room_12)
DECLARE_ROM_SEGMENT(ddan_room_13)
DECLARE_ROM_SEGMENT(ddan_room_14)
DECLARE_ROM_SEGMENT(ddan_room_15)
DECLARE_ROM_SEGMENT(ddan_room_16)

DECLARE_ROM_SEGMENT(bdan_scene)
DECLARE_ROM_SEGMENT(bdan_room_0)
DECLARE_ROM_SEGMENT(bdan_room_1)
DECLARE_ROM_SEGMENT(bdan_room_2)
DECLARE_ROM_SEGMENT(bdan_room_3)
DECLARE_ROM_SEGMENT(bdan_room_4)
DECLARE_ROM_SEGMENT(bdan_room_5)
DECLARE_ROM_SEGMENT(bdan_room_6)
DECLARE_ROM_SEGMENT(bdan_room_7)
DECLARE_ROM_SEGMENT(bdan_room_8)
DECLARE_ROM_SEGMENT(bdan_room_9)
DECLARE_ROM_SEGMENT(bdan_room_10)
DECLARE_ROM_SEGMENT(bdan_room_11)
DECLARE_ROM_SEGMENT(bdan_room_12)
DECLARE_ROM_SEGMENT(bdan_room_13)
DECLARE_ROM_SEGMENT(bdan_room_14)
DECLARE_ROM_SEGMENT(bdan_room_15)

DECLARE_ROM_SEGMENT(Bmori1_scene)
DECLARE_ROM_SEGMENT(Bmori1_room_0)
DECLARE_ROM_SEGMENT(Bmori1_room_1)
DECLARE_ROM_SEGMENT(Bmori1_room_2)
DECLARE_ROM_SEGMENT(Bmori1_room_3)
DECLARE_ROM_SEGMENT(Bmori1_room_4)
DECLARE_ROM_SEGMENT(Bmori1_room_5)
DECLARE_ROM_SEGMENT(Bmori1_room_6)
DECLARE_ROM_SEGMENT(Bmori1_room_7)
DECLARE_ROM_SEGMENT(Bmori1_room_8)
DECLARE_ROM_SEGMENT(Bmori1_room_9)
DECLARE_ROM_SEGMENT(Bmori1_room_10)
DECLARE_ROM_SEGMENT(Bmori1_room_11)
DECLARE_ROM_SEGMENT(Bmori1_room_12)
DECLARE_ROM_SEGMENT(Bmori1_room_13)
DECLARE_ROM_SEGMENT(Bmori1_room_14)
DECLARE_ROM_SEGMENT(Bmori1_room_15)
DECLARE_ROM_SEGMENT(Bmori1_room_16)
DECLARE_ROM_SEGMENT(Bmori1_room_17)
DECLARE_ROM_SEGMENT(Bmori1_room_18)
DECLARE_ROM_SEGMENT(Bmori1_room_19)
DECLARE_ROM_SEGMENT(Bmori1_room_20)
DECLARE_ROM_SEGMENT(Bmori1_room_21)
DECLARE_ROM_SEGMENT(Bmori1_room_22)

DECLARE_ROM_SEGMENT(HIDAN_scene)
DECLARE_ROM_SEGMENT(HIDAN_room_0)
DECLARE_ROM_SEGMENT(HIDAN_room_1)
DECLARE_ROM_SEGMENT(HIDAN_room_2)
DECLARE_ROM_SEGMENT(HIDAN_room_3)
DECLARE_ROM_SEGMENT(HIDAN_room_4)
DECLARE_ROM_SEGMENT(HIDAN_room_5)
DECLARE_ROM_SEGMENT(HIDAN_room_6)
DECLARE_ROM_SEGMENT(HIDAN_room_7)
DECLARE_ROM_SEGMENT(HIDAN_room_8)
DECLARE_ROM_SEGMENT(HIDAN_room_9)
DECLARE_ROM_SEGMENT(HIDAN_room_10)
DECLARE_ROM_SEGMENT(HIDAN_room_11)
DECLARE_ROM_SEGMENT(HIDAN_room_12)
DECLARE_ROM_SEGMENT(HIDAN_room_13)
DECLARE_ROM_SEGMENT(HIDAN_room_14)
DECLARE_ROM_SEGMENT(HIDAN_room_15)
DECLARE_ROM_SEGMENT(HIDAN_room_16)
DECLARE_ROM_SEGMENT(HIDAN_room_17)
DECLARE_ROM_SEGMENT(HIDAN_room_18)
DECLARE_ROM_SEGMENT(HIDAN_room_19)
DECLARE_ROM_SEGMENT(HIDAN_room_20)
DECLARE_ROM_SEGMENT(HIDAN_room_21)
DECLARE_ROM_SEGMENT(HIDAN_room_22)
DECLARE_ROM_SEGMENT(HIDAN_room_23)
DECLARE_ROM_SEGMENT(HIDAN_room_24)
DECLARE_ROM_SEGMENT(HIDAN_room_25)
DECLARE_ROM_SEGMENT(HIDAN_room_26)

DECLARE_ROM_SEGMENT(MIZUsin_scene)
DECLARE_ROM_SEGMENT(MIZUsin_room_0)
DECLARE_ROM_SEGMENT(MIZUsin_room_1)
DECLARE_ROM_SEGMENT(MIZUsin_room_2)
DECLARE_ROM_SEGMENT(MIZUsin_room_3)
DECLARE_ROM_SEGMENT(MIZUsin_room_4)
DECLARE_ROM_SEGMENT(MIZUsin_room_5)
DECLARE_ROM_SEGMENT(MIZUsin_room_6)
DECLARE_ROM_SEGMENT(MIZUsin_room_7)
DECLARE_ROM_SEGMENT(MIZUsin_room_8)
DECLARE_ROM_SEGMENT(MIZUsin_room_9)
DECLARE_ROM_SEGMENT(MIZUsin_room_10)
DECLARE_ROM_SEGMENT(MIZUsin_room_11)
DECLARE_ROM_SEGMENT(MIZUsin_room_12)
DECLARE_ROM_SEGMENT(MIZUsin_room_13)
DECLARE_ROM_SEGMENT(MIZUsin_room_14)
DECLARE_ROM_SEGMENT(MIZUsin_room_15)
DECLARE_ROM_SEGMENT(MIZUsin_room_16)
DECLARE_ROM_SEGMENT(MIZUsin_room_17)
DECLARE_ROM_SEGMENT(MIZUsin_room_18)
DECLARE_ROM_SEGMENT(MIZUsin_room_19)
DECLARE_ROM_SEGMENT(MIZUsin_room_20)
DECLARE_ROM_SEGMENT(MIZUsin_room_21)
DECLARE_ROM_SEGMENT(MIZUsin_room_22)

DECLARE_ROM_SEGMENT(jyasinzou_scene)
DECLARE_ROM_SEGMENT(jyasinzou_room_0)
DECLARE_ROM_SEGMENT(jyasinzou_room_1)
DECLARE_ROM_SEGMENT(jyasinzou_room_2)
DECLARE_ROM_SEGMENT(jyasinzou_room_3)
DECLARE_ROM_SEGMENT(jyasinzou_room_4)
DECLARE_ROM_SEGMENT(jyasinzou_room_5)
DECLARE_ROM_SEGMENT(jyasinzou_room_6)
DECLARE_ROM_SEGMENT(jyasinzou_room_7)
DECLARE_ROM_SEGMENT(jyasinzou_room_8)
DECLARE_ROM_SEGMENT(jyasinzou_room_9)
DECLARE_ROM_SEGMENT(jyasinzou_room_10)
DECLARE_ROM_SEGMENT(jyasinzou_room_11)
DECLARE_ROM_SEGMENT(jyasinzou_room_12)
DECLARE_ROM_SEGMENT(jyasinzou_room_13)
DECLARE_ROM_SEGMENT(jyasinzou_room_14)
DECLARE_ROM_SEGMENT(jyasinzou_room_15)
DECLARE_ROM_SEGMENT(jyasinzou_room_16)
DECLARE_ROM_SEGMENT(jyasinzou_room_17)
DECLARE_ROM_SEGMENT(jyasinzou_room_18)
DECLARE_ROM_SEGMENT(jyasinzou_room_19)
DECLARE_ROM_SEGMENT(jyasinzou_room_20)
DECLARE_ROM_SEGMENT(jyasinzou_room_21)
DECLARE_ROM_SEGMENT(jyasinzou_room_22)
DECLARE_ROM_SEGMENT(jyasinzou_room_23)
DECLARE_ROM_SEGMENT(jyasinzou_room_24)
DECLARE_ROM_SEGMENT(jyasinzou_room_25)
DECLARE_ROM_SEGMENT(jyasinzou_room_26)
DECLARE_ROM_SEGMENT(jyasinzou_room_27)
DECLARE_ROM_SEGMENT(jyasinzou_room_28)

DECLARE_ROM_SEGMENT(HAKAdan_scene)
DECLARE_ROM_SEGMENT(HAKAdan_room_0)
DECLARE_ROM_SEGMENT(HAKAdan_room_1)
DECLARE_ROM_SEGMENT(HAKAdan_room_2)
DECLARE_ROM_SEGMENT(HAKAdan_room_3)
DECLARE_ROM_SEGMENT(HAKAdan_room_4)
DECLARE_ROM_SEGMENT(HAKAdan_room_5)
DECLARE_ROM_SEGMENT(HAKAdan_room_6)
DECLARE_ROM_SEGMENT(HAKAdan_room_7)
DECLARE_ROM_SEGMENT(HAKAdan_room_8)
DECLARE_ROM_SEGMENT(HAKAdan_room_9)
DECLARE_ROM_SEGMENT(HAKAdan_room_10)
DECLARE_ROM_SEGMENT(HAKAdan_room_11)
DECLARE_ROM_SEGMENT(HAKAdan_room_12)
DECLARE_ROM_SEGMENT(HAKAdan_room_13)
DECLARE_ROM_SEGMENT(HAKAdan_room_14)
DECLARE_ROM_SEGMENT(HAKAdan_room_15)
DECLARE_ROM_SEGMENT(HAKAdan_room_16)
DECLARE_ROM_SEGMENT(HAKAdan_room_17)
DECLARE_ROM_SEGMENT(HAKAdan_room_18)
DECLARE_ROM_SEGMENT(HAKAdan_room_19)
DECLARE_ROM_SEGMENT(HAKAdan_room_20)
DECLARE_ROM_SEGMENT(HAKAdan_room_21)
DECLARE_ROM_SEGMENT(HAKAdan_room_22)

DECLARE_ROM_SEGMENT(HAKAdanCH_scene)
DECLARE_ROM_SEGMENT(HAKAdanCH_room_0)
DECLARE_ROM_SEGMENT(HAKAdanCH_room_1)
DECLARE_ROM_SEGMENT(HAKAdanCH_room_2)
DECLARE_ROM_SEGMENT(HAKAdanCH_room_3)
DECLARE_ROM_SEGMENT(HAKAdanCH_room_4)
DECLARE_ROM_SEGMENT(HAKAdanCH_room_5)
DECLARE_ROM_SEGMENT(HAKAdanCH_room_6)

DECLARE_ROM_SEGMENT(ice_doukutu_scene)
DECLARE_ROM_SEGMENT(ice_doukutu_room_0)
DECLARE_ROM_SEGMENT(ice_doukutu_room_1)
DECLARE_ROM_SEGMENT(ice_doukutu_room_2)
DECLARE_ROM_SEGMENT(ice_doukutu_room_3)
DECLARE_ROM_SEGMENT(ice_doukutu_room_4)
DECLARE_ROM_SEGMENT(ice_doukutu_room_5)
DECLARE_ROM_SEGMENT(ice_doukutu_room_6)
DECLARE_ROM_SEGMENT(ice_doukutu_room_7)
DECLARE_ROM_SEGMENT(ice_doukutu_room_8)
DECLARE_ROM_SEGMENT(ice_doukutu_room_9)
DECLARE_ROM_SEGMENT(ice_doukutu_room_10)
DECLARE_ROM_SEGMENT(ice_doukutu_room_11)

DECLARE_ROM_SEGMENT(ganon_scene)
DECLARE_ROM_SEGMENT(ganon_room_0)
DECLARE_ROM_SEGMENT(ganon_room_1)
DECLARE_ROM_SEGMENT(ganon_room_2)
DECLARE_ROM_SEGMENT(ganon_room_3)
DECLARE_ROM_SEGMENT(ganon_room_4)
DECLARE_ROM_SEGMENT(ganon_room_5)
DECLARE_ROM_SEGMENT(ganon_room_6)
DECLARE_ROM_SEGMENT(ganon_room_7)
DECLARE_ROM_SEGMENT(ganon_room_8)
DECLARE_ROM_SEGMENT(ganon_room_9)

DECLARE_ROM_SEGMENT(men_scene)
DECLARE_ROM_SEGMENT(men_room_0)
DECLARE_ROM_SEGMENT(men_room_1)
DECLARE_ROM_SEGMENT(men_room_2)
DECLARE_ROM_SEGMENT(men_room_3)
DECLARE_ROM_SEGMENT(men_room_4)
DECLARE_ROM_SEGMENT(men_room_5)
DECLARE_ROM_SEGMENT(men_room_6)
DECLARE_ROM_SEGMENT(men_room_7)
DECLARE_ROM_SEGMENT(men_room_8)
DECLARE_ROM_SEGMENT(men_room_9)
DECLARE_ROM_SEGMENT(men_room_10)

DECLARE_ROM_SEGMENT(gerudoway_scene)
DECLARE_ROM_SEGMENT(gerudoway_room_0)
DECLARE_ROM_SEGMENT(gerudoway_room_1)
DECLARE_ROM_SEGMENT(gerudoway_room_2)
DECLARE_ROM_SEGMENT(gerudoway_room_3)
DECLARE_ROM_SEGMENT(gerudoway_room_4)
DECLARE_ROM_SEGMENT(gerudoway_room_5)

DECLARE_ROM_SEGMENT(ganontika_scene)
DECLARE_ROM_SEGMENT(ganontika_room_0)
DECLARE_ROM_SEGMENT(ganontika_room_1)
DECLARE_ROM_SEGMENT(ganontika_room_2)
DECLARE_ROM_SEGMENT(ganontika_room_3)
DECLARE_ROM_SEGMENT(ganontika_room_4)
DECLARE_ROM_SEGMENT(ganontika_room_5)
DECLARE_ROM_SEGMENT(ganontika_room_6)
DECLARE_ROM_SEGMENT(ganontika_room_7)
DECLARE_ROM_SEGMENT(ganontika_room_8)
DECLARE_ROM_SEGMENT(ganontika_room_9)
DECLARE_ROM_SEGMENT(ganontika_room_10)
DECLARE_ROM_SEGMENT(ganontika_room_11)
DECLARE_ROM_SEGMENT(ganontika_room_12)
DECLARE_ROM_SEGMENT(ganontika_room_13)
DECLARE_ROM_SEGMENT(ganontika_room_14)
DECLARE_ROM_SEGMENT(ganontika_room_15)
DECLARE_ROM_SEGMENT(ganontika_room_16)
DECLARE_ROM_SEGMENT(ganontika_room_17)
DECLARE_ROM_SEGMENT(ganontika_room_18)
DECLARE_ROM_SEGMENT(ganontika_room_19)

DECLARE_ROM_SEGMENT(ganon_sonogo_scene)
DECLARE_ROM_SEGMENT(ganon_sonogo_room_0)
DECLARE_ROM_SEGMENT(ganon_sonogo_room_1)
DECLARE_ROM_SEGMENT(ganon_sonogo_room_2)
DECLARE_ROM_SEGMENT(ganon_sonogo_room_3)
DECLARE_ROM_SEGMENT(ganon_sonogo_room_4)

DECLARE_ROM_SEGMENT(ganontikasonogo_scene)
DECLARE_ROM_SEGMENT(ganontikasonogo_room_0)
DECLARE_ROM_SEGMENT(ganontikasonogo_room_1)

DECLARE_ROM_SEGMENT(takaraya_scene)
DECLARE_ROM_SEGMENT(takaraya_room_0)
DECLARE_ROM_SEGMENT(takaraya_room_1)
DECLARE_ROM_SEGMENT(takaraya_room_2)
DECLARE_ROM_SEGMENT(takaraya_room_3)
DECLARE_ROM_SEGMENT(takaraya_room_4)
DECLARE_ROM_SEGMENT(takaraya_room_5)
DECLARE_ROM_SEGMENT(takaraya_room_6)

DECLARE_ROM_SEGMENT(ydan_boss_scene)
DECLARE_ROM_SEGMENT(ydan_boss_room_0)
DECLARE_ROM_SEGMENT(ydan_boss_room_1)

DECLARE_ROM_SEGMENT(ddan_boss_scene)
DECLARE_ROM_SEGMENT(ddan_boss_room_0)
DECLARE_ROM_SEGMENT(ddan_boss_room_1)

DECLARE_ROM_SEGMENT(bdan_boss_scene)
DECLARE_ROM_SEGMENT(bdan_boss_room_0)
DECLARE_ROM_SEGMENT(bdan_boss_room_1)

DECLARE_ROM_SEGMENT(moribossroom_scene)
DECLARE_ROM_SEGMENT(moribossroom_room_0)
DECLARE_ROM_SEGMENT(moribossroom_room_1)

DECLARE_ROM_SEGMENT(FIRE_bs_scene)
DECLARE_ROM_SEGMENT(FIRE_bs_room_0)
DECLARE_ROM_SEGMENT(FIRE_bs_room_1)

DECLARE_ROM_SEGMENT(MIZUsin_bs_scene)
DECLARE_ROM_SEGMENT(MIZUsin_bs_room_0)
DECLARE_ROM_SEGMENT(MIZUsin_bs_room_1)

DECLARE_ROM_SEGMENT(jyasinboss_scene)
DECLARE_ROM_SEGMENT(jyasinboss_room_0)
DECLARE_ROM_SEGMENT(jyasinboss_room_1)
DECLARE_ROM_SEGMENT(jyasinboss_room_2)
DECLARE_ROM_SEGMENT(jyasinboss_room_3)

DECLARE_ROM_SEGMENT(HAKAdan_bs_scene)
DECLARE_ROM_SEGMENT(HAKAdan_bs_room_0)
DECLARE_ROM_SEGMENT(HAKAdan_bs_room_1)

DECLARE_ROM_SEGMENT(ganon_boss_scene)
DECLARE_ROM_SEGMENT(ganon_boss_room_0)

DECLARE_ROM_SEGMENT(ganon_final_scene)
DECLARE_ROM_SEGMENT(ganon_final_room_0)

DECLARE_ROM_SEGMENT(entra_scene)
DECLARE_ROM_SEGMENT(entra_room_0)

DECLARE_ROM_SEGMENT(entra_n_scene)
DECLARE_ROM_SEGMENT(entra_n_room_0)

DECLARE_ROM_SEGMENT(enrui_scene)
DECLARE_ROM_SEGMENT(enrui_room_0)

DECLARE_ROM_SEGMENT(market_alley_scene)
DECLARE_ROM_SEGMENT(market_alley_room_0)

DECLARE_ROM_SEGMENT(market_alley_n_scene)
DECLARE_ROM_SEGMENT(market_alley_n_room_0)

DECLARE_ROM_SEGMENT(market_day_scene)
DECLARE_ROM_SEGMENT(market_day_room_0)

DECLARE_ROM_SEGMENT(market_night_scene)
DECLARE_ROM_SEGMENT(market_night_room_0)

DECLARE_ROM_SEGMENT(market_ruins_scene)
DECLARE_ROM_SEGMENT(market_ruins_room_0)

DECLARE_ROM_SEGMENT(shrine_scene)
DECLARE_ROM_SEGMENT(shrine_room_0)

DECLARE_ROM_SEGMENT(shrine_n_scene)
DECLARE_ROM_SEGMENT(shrine_n_room_0)

DECLARE_ROM_SEGMENT(shrine_r_scene)
DECLARE_ROM_SEGMENT(shrine_r_room_0)

DECLARE_ROM_SEGMENT(kokiri_home_scene)
DECLARE_ROM_SEGMENT(kokiri_home_room_0)

DECLARE_ROM_SEGMENT(kokiri_home3_scene)
DECLARE_ROM_SEGMENT(kokiri_home3_room_0)

DECLARE_ROM_SEGMENT(kokiri_home4_scene)
DECLARE_ROM_SEGMENT(kokiri_home4_room_0)

DECLARE_ROM_SEGMENT(kokiri_home5_scene)
DECLARE_ROM_SEGMENT(kokiri_home5_room_0)

DECLARE_ROM_SEGMENT(kakariko_scene)
DECLARE_ROM_SEGMENT(kakariko_room_0)

DECLARE_ROM_SEGMENT(kakariko3_scene)
DECLARE_ROM_SEGMENT(kakariko3_room_0)

DECLARE_ROM_SEGMENT(shop1_scene)
DECLARE_ROM_SEGMENT(shop1_room_0)

DECLARE_ROM_SEGMENT(kokiri_shop_scene)
DECLARE_ROM_SEGMENT(kokiri_shop_room_0)

DECLARE_ROM_SEGMENT(golon_scene)
DECLARE_ROM_SEGMENT(golon_room_0)

DECLARE_ROM_SEGMENT(zoora_scene)
DECLARE_ROM_SEGMENT(zoora_room_0)

DECLARE_ROM_SEGMENT(drag_scene)
DECLARE_ROM_SEGMENT(drag_room_0)

DECLARE_ROM_SEGMENT(alley_shop_scene)
DECLARE_ROM_SEGMENT(alley_shop_room_0)

DECLARE_ROM_SEGMENT(night_shop_scene)
DECLARE_ROM_SEGMENT(night_shop_room_0)

DECLARE_ROM_SEGMENT(face_shop_scene)
DECLARE_ROM_SEGMENT(face_shop_room_0)

DECLARE_ROM_SEGMENT(link_home_scene)
DECLARE_ROM_SEGMENT(link_home_room_0)

DECLARE_ROM_SEGMENT(impa_scene)
DECLARE_ROM_SEGMENT(impa_room_0)

DECLARE_ROM_SEGMENT(malon_stable_scene)
DECLARE_ROM_SEGMENT(malon_stable_room_0)

DECLARE_ROM_SEGMENT(labo_scene)
DECLARE_ROM_SEGMENT(labo_room_0)

DECLARE_ROM_SEGMENT(hylia_labo_scene)
DECLARE_ROM_SEGMENT(hylia_labo_room_0)

DECLARE_ROM_SEGMENT(tent_scene)
DECLARE_ROM_SEGMENT(tent_room_0)

DECLARE_ROM_SEGMENT(hut_scene)
DECLARE_ROM_SEGMENT(hut_room_0)

DECLARE_ROM_SEGMENT(daiyousei_izumi_scene)
DECLARE_ROM_SEGMENT(daiyousei_izumi_room_0)

DECLARE_ROM_SEGMENT(yousei_izumi_tate_scene)
DECLARE_ROM_SEGMENT(yousei_izumi_tate_room_0)

DECLARE_ROM_SEGMENT(yousei_izumi_yoko_scene)
DECLARE_ROM_SEGMENT(yousei_izumi_yoko_room_0)

DECLARE_ROM_SEGMENT(kakusiana_scene)
DECLARE_ROM_SEGMENT(kakusiana_room_0)
DECLARE_ROM_SEGMENT(kakusiana_room_1)
DECLARE_ROM_SEGMENT(kakusiana_room_2)
DECLARE_ROM_SEGMENT(kakusiana_room_3)
DECLARE_ROM_SEGMENT(kakusiana_room_4)
DECLARE_ROM_SEGMENT(kakusiana_room_5)
DECLARE_ROM_SEGMENT(kakusiana_room_6)
DECLARE_ROM_SEGMENT(kakusiana_room_7)
DECLARE_ROM_SEGMENT(kakusiana_room_8)
DECLARE_ROM_SEGMENT(kakusiana_room_9)
DECLARE_ROM_SEGMENT(kakusiana_room_10)
DECLARE_ROM_SEGMENT(kakusiana_room_11)
DECLARE_ROM_SEGMENT(kakusiana_room_12)
DECLARE_ROM_SEGMENT(kakusiana_room_13)

DECLARE_ROM_SEGMENT(hakaana_scene)
DECLARE_ROM_SEGMENT(hakaana_room_0)

DECLARE_ROM_SEGMENT(hakaana2_scene)
DECLARE_ROM_SEGMENT(hakaana2_room_0)

DECLARE_ROM_SEGMENT(hakaana_ouke_scene)
DECLARE_ROM_SEGMENT(hakaana_ouke_room_0)
DECLARE_ROM_SEGMENT(hakaana_ouke_room_1)
DECLARE_ROM_SEGMENT(hakaana_ouke_room_2)

DECLARE_ROM_SEGMENT(syatekijyou_scene)
DECLARE_ROM_SEGMENT(syatekijyou_room_0)

DECLARE_ROM_SEGMENT(tokinoma_scene)
DECLARE_ROM_SEGMENT(tokinoma_room_0)
DECLARE_ROM_SEGMENT(tokinoma_room_1)

DECLARE_ROM_SEGMENT(kenjyanoma_scene)
DECLARE_ROM_SEGMENT(kenjyanoma_room_0)

DECLARE_ROM_SEGMENT(hairal_niwa_scene)
DECLARE_ROM_SEGMENT(hairal_niwa_room_0)

DECLARE_ROM_SEGMENT(hairal_niwa_n_scene)
DECLARE_ROM_SEGMENT(hairal_niwa_n_room_0)

DECLARE_ROM_SEGMENT(hiral_demo_scene)
DECLARE_ROM_SEGMENT(hiral_demo_room_0)

DECLARE_ROM_SEGMENT(hakasitarelay_scene)
DECLARE_ROM_SEGMENT(hakasitarelay_room_0)
DECLARE_ROM_SEGMENT(hakasitarelay_room_1)
DECLARE_ROM_SEGMENT(hakasitarelay_room_2)
DECLARE_ROM_SEGMENT(hakasitarelay_room_3)
DECLARE_ROM_SEGMENT(hakasitarelay_room_4)
DECLARE_ROM_SEGMENT(hakasitarelay_room_5)
DECLARE_ROM_SEGMENT(hakasitarelay_room_6)

DECLARE_ROM_SEGMENT(turibori_scene)
DECLARE_ROM_SEGMENT(turibori_room_0)

DECLARE_ROM_SEGMENT(nakaniwa_scene)
DECLARE_ROM_SEGMENT(nakaniwa_room_0)

DECLARE_ROM_SEGMENT(bowling_scene)
DECLARE_ROM_SEGMENT(bowling_room_0)

DECLARE_ROM_SEGMENT(souko_scene)
DECLARE_ROM_SEGMENT(souko_room_0)
DECLARE_ROM_SEGMENT(souko_room_1)
DECLARE_ROM_SEGMENT(souko_room_2)

DECLARE_ROM_SEGMENT(miharigoya_scene)
DECLARE_ROM_SEGMENT(miharigoya_room_0)

DECLARE_ROM_SEGMENT(mahouya_scene)
DECLARE_ROM_SEGMENT(mahouya_room_0)

DECLARE_ROM_SEGMENT(ganon_demo_scene)
DECLARE_ROM_SEGMENT(ganon_demo_room_0)

DECLARE_ROM_SEGMENT(kinsuta_scene)
DECLARE_ROM_SEGMENT(kinsuta_room_0)

DECLARE_ROM_SEGMENT(spot00_scene)
DECLARE_ROM_SEGMENT(spot00_room_0)

DECLARE_ROM_SEGMENT(spot01_scene)
DECLARE_ROM_SEGMENT(spot01_room_0)

DECLARE_ROM_SEGMENT(spot02_scene)
DECLARE_ROM_SEGMENT(spot02_room_0)
DECLARE_ROM_SEGMENT(spot02_room_1)

DECLARE_ROM_SEGMENT(spot03_scene)
DECLARE_ROM_SEGMENT(spot03_room_0)
DECLARE_ROM_SEGMENT(spot03_room_1)

DECLARE_ROM_SEGMENT(spot04_scene)
DECLARE_ROM_SEGMENT(spot04_room_0)
DECLARE_ROM_SEGMENT(spot04_room_1)
DECLARE_ROM_SEGMENT(spot04_room_2)

DECLARE_ROM_SEGMENT(spot05_scene)
DECLARE_ROM_SEGMENT(spot05_room_0)

DECLARE_ROM_SEGMENT(spot06_scene)
DECLARE_ROM_SEGMENT(spot06_room_0)

DECLARE_ROM_SEGMENT(spot07_scene)
DECLARE_ROM_SEGMENT(spot07_room_0)
DECLARE_ROM_SEGMENT(spot07_room_1)

DECLARE_ROM_SEGMENT(spot08_scene)
DECLARE_ROM_SEGMENT(spot08_room_0)

DECLARE_ROM_SEGMENT(spot09_scene)
DECLARE_ROM_SEGMENT(spot09_room_0)

DECLARE_ROM_SEGMENT(spot10_scene)
DECLARE_ROM_SEGMENT(spot10_room_0)
DECLARE_ROM_SEGMENT(spot10_room_1)
DECLARE_ROM_SEGMENT(spot10_room_2)
DECLARE_ROM_SEGMENT(spot10_room_3)
DECLARE_ROM_SEGMENT(spot10_room_4)
DECLARE_ROM_SEGMENT(spot10_room_5)
DECLARE_ROM_SEGMENT(spot10_room_6)
DECLARE_ROM_SEGMENT(spot10_room_7)
DECLARE_ROM_SEGMENT(spot10_room_8)
DECLARE_ROM_SEGMENT(spot10_room_9)

DECLARE_ROM_SEGMENT(spot11_scene)
DECLARE_ROM_SEGMENT(spot11_room_0)

DECLARE_ROM_SEGMENT(spot12_scene)
DECLARE_ROM_SEGMENT(spot12_room_0)
DECLARE_ROM_SEGMENT(spot12_room_1)

DECLARE_ROM_SEGMENT(spot13_scene)
DECLARE_ROM_SEGMENT(spot13_room_0)
DECLARE_ROM_SEGMENT(spot13_room_1)

DECLARE_ROM_SEGMENT(spot15_scene)
DECLARE_ROM_SEGMENT(spot15_room_0)

DECLARE_ROM_SEGMENT(spot16_scene)
DECLARE_ROM_SEGMENT(spot16_room_0)

DECLARE_ROM_SEGMENT(spot17_scene)
DECLARE_ROM_SEGMENT(spot17_room_0)
DECLARE_ROM_SEGMENT(spot17_room_1)

DECLARE_ROM_SEGMENT(spot18_scene)
DECLARE_ROM_SEGMENT(spot18_room_0)
DECLARE_ROM_SEGMENT(spot18_room_1)
DECLARE_ROM_SEGMENT(spot18_room_2)
DECLARE_ROM_SEGMENT(spot18_room_3)

DECLARE_ROM_SEGMENT(spot20_scene)
DECLARE_ROM_SEGMENT(spot20_room_0)

DECLARE_ROM_SEGMENT(ganon_tou_scene)
DECLARE_ROM_SEGMENT(ganon_tou_room_0)

DECLARE_ROM_SEGMENT(test01_scene)
DECLARE_ROM_SEGMENT(test01_room_0)

DECLARE_ROM_SEGMENT(besitu_scene)
DECLARE_ROM_SEGMENT(besitu_room_0)

DECLARE_ROM_SEGMENT(depth_test_scene)
DECLARE_ROM_SEGMENT(depth_test_room_0)

DECLARE_ROM_SEGMENT(syotes_scene)
DECLARE_ROM_SEGMENT(syotes_room_0)

DECLARE_ROM_SEGMENT(syotes2_scene)
DECLARE_ROM_SEGMENT(syotes2_room_0)

DECLARE_ROM_SEGMENT(sutaru_scene)
DECLARE_ROM_SEGMENT(sutaru_room_0)

DECLARE_ROM_SEGMENT(hairal_niwa2_scene)
DECLARE_ROM_SEGMENT(hairal_niwa2_room_0)

DECLARE_ROM_SEGMENT(sasatest_scene)
DECLARE_ROM_SEGMENT(sasatest_room_0)

DECLARE_ROM_SEGMENT(testroom_scene)
DECLARE_ROM_SEGMENT(testroom_room_0)
DECLARE_ROM_SEGMENT(testroom_room_1)
DECLARE_ROM_SEGMENT(testroom_room_2)
DECLARE_ROM_SEGMENT(testroom_room_3)
DECLARE_ROM_SEGMENT(testroom_room_4)


#endif
